// calcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "calc.h"
#include "calcDlg.h"
#include "ifaccalc.h"
#include "guidcalc.cpp"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalcDlg dialog

CCalcDlg::CCalcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalcDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//   
	//     
	HRESULT hr;
	hr=CoInitialize(NULL);

	if(!SUCCEEDED(hr))
	{
		CWnd::MessageBox("CoInizialize() not passed!");
	};

	hr = ::CoCreateInstance(CLSID_AVACALCKERNEL, 
				NULL,
				CLSCTX_INPROC_SERVER,
				IID_CALCKERNELPROC,
				(void**)&pKernel);
	
	if(!SUCCEEDED(hr))
	{
		CWnd::MessageBox("CoreateInstance() not passed!");
	};

	hr = pKernel->QueryInterface(IID_LCDACCESS, (void**)&pAccess);
	
	if(!SUCCEEDED(hr))
	{
		CWnd::MessageBox("QueryInterface() not passed!");
	};

  }

CCalcDlg::~CCalcDlg()
{
	pAccess->Release();
	pKernel->Release();
  CoUninitialize();
}

void CCalcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalcDlg)
	DDX_Control(pDX, IDC_EDIT1, m_edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCalcDlg, CDialog)
	//{{AFX_MSG_MAP(CCalcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON0, OnButton0)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTONA, OnButtona)
	ON_BN_CLICKED(IDC_BUTTONB, OnButtonb)
	ON_BN_CLICKED(IDC_BUTTONC, OnButtonc)
	ON_BN_CLICKED(IDC_BUTTONCLEAR, OnButtonclear)
	ON_BN_CLICKED(IDC_BUTTOND, OnButtond)
	ON_BN_CLICKED(IDC_BUTTONDIVIS, OnButtondivis)
	ON_BN_CLICKED(IDC_BUTTONE, OnButtone)
	ON_BN_CLICKED(IDC_BUTTONF, OnButtonf)
	ON_BN_CLICKED(IDC_BUTTONMINUS, OnButtonminus)
	ON_BN_CLICKED(IDC_BUTTONMULTI, OnButtonmulti)
	ON_BN_CLICKED(IDC_BUTTONPLUS, OnButtonplus)
	ON_BN_CLICKED(IDC_BUTTONPOINT, OnButtonpoint)
	ON_BN_CLICKED(IDC_BUTTONPUSH, OnButtonpush)
	ON_BN_CLICKED(IDC_BUTTONDEC, OnButtondec)
	ON_BN_CLICKED(IDC_BUTTONHEX, OnButtonhex)
	ON_BN_CLICKED(IDC_BUTTONOCT, OnButtonoct)
	ON_BN_CLICKED(IDC_BUTTONReset, OnBUTTONReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalcDlg message handlers

BOOL CCalcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCalcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCalcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCalcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCalcDlg::OnButton0() 
{
	// TODO: Add your control notification handler code here
	OnButton("0");
}

void CCalcDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	OnButton("1");
}


void CCalcDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	OnButton("2");	
}

void CCalcDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	OnButton("3");
}

void CCalcDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	OnButton("4");
}

void CCalcDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	OnButton("5");
}

void CCalcDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	OnButton("6");
}

void CCalcDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	OnButton("7");
}

void CCalcDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	OnButton("8");
}

void CCalcDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	OnButton("9");
}

void CCalcDlg::OnButtona() 
{
	// TODO: Add your control notification handler code here
	OnButton("A");
}

void CCalcDlg::OnButtonb() 
{
	// TODO: Add your control notification handler code here
	OnButton("B");
}

void CCalcDlg::OnButtonc() 
{
	// TODO: Add your control notification handler code here
	OnButton("C");
}

void CCalcDlg::OnButtonclear() 
{
	// TODO: Add your control notification handler code here
	OnButton("Clear");
}

void CCalcDlg::OnButtond() 
{
	// TODO: Add your control notification handler code here
	OnButton("D");
}

void CCalcDlg::OnButtondivis() 
{
	// TODO: Add your control notification handler code here
	OnButton("Div");
}

void CCalcDlg::OnButtone() 
{
	// TODO: Add your control notification handler code here
	OnButton("E");
}

void CCalcDlg::OnButtonf() 
{
	// TODO: Add your control notification handler code here
	OnButton("F");
}

void CCalcDlg::OnButtonminus() 
{
	// TODO: Add your control notification handler code here
	OnButton("Sub");
}

void CCalcDlg::OnButtonmulti() 
{
	// TODO: Add your control notification handler code here
	OnButton("Mul");
}

void CCalcDlg::OnButtonplus() 
{
	// TODO: Add your control notification handler code here
	OnButton("Add");
}

void CCalcDlg::OnButtonpoint() 
{
	// TODO: Add your control notification handler code here
	OnButton(".");
}

void CCalcDlg::OnButtonpush() 
{
	// TODO: Add your control notification handler code here
	OnButton("Push");
}

void CCalcDlg::OnButtonoct() 
{
	// TODO: Add your control notification handler code here
	OnButton("Oct");
}

void CCalcDlg::OnButtondec() 
{
	// TODO: Add your control notification handler code here
	OnButton("Dec");
}

void CCalcDlg::OnButtonhex() 
{
	// TODO: Add your control notification handler code here
	OnButton("Hex");
}

void CCalcDlg::OnBUTTONReset() 
{
	// TODO: Add your control notification handler code here
	OnButton("Reset");	
}


void CCalcDlg::OnButton(char *sz)
{
	char str[50];
	pKernel->NextCommand(sz);
//	CWnd::SetWindowText(sz);

	pAccess->GetString(str);
//CWnd::MessageBox(str);
	m_edit.SetWindowText(str);
}
